#!/usr/bin/env python
# encoding: utf-8
"""
dispatcher.py

This class will dispatch incoming and outgoing messages to
the correct destinations

Created by Elliot Pennington on 2008-11-16.
"""

import unittest
from befriender import *
from message import Message
import commands
import net_info

convotable = []
befrienders = Befrienders()
last_befriender = None
server = None

def dispatch(msg, serv):
    """Dispatch a message to proper location"""
    msg.encrypt()
    dispatcher.server = serv
    sn = msg.getSn()
    exists = False
    for convo in convotable:
        if sn == convo.client:
            exists = True
            sendin(msg, convo.befriender)
            break
    if not exists:
        sendin(msg, befrienders[last_befriender.next()])

def sendin(msg):
    """
    Send a message into the network, to a befriender
    @arg msg should be of type Message
    """
    if not befrienders.empty():
        befrienders.next().getSock().sendall(msg.serialize())
    else:
        sendout(Message("%s::en:%s" % (msg.getSn(), net_info.default_busy_msg)))
    
def sendout(msg):
    """
    Make the bot send the message out
    """
    server.on_IM_OUT(msg)
    
def dispatch_internal_msg(msg, sock):
    """
    We'll be receiving several types of messages from the befriender clients.
    Some are commands and some are outgoing messages.
    This method has to sort them out. 
    """
    if (msg.getSn() == "~server"):
        print "internal server command!"
        parse_cmd(msg, sock)
    else:
        sendout(msg)
    
    
def parse_cmd(msg, sock):
    print "INSTRUCTION: " + msg.getMsg()[0]
    exec("commands.cmd_%s(msg.getMsg()[1:], sock)" % msg.getMsg()[0])

class dispatcherTests(unittest.TestCase):
    def setUp(self):
        pass
    
    def sendoutTest(self): 
        msg = Message("esp1337:stuff:en:lololol aids haha.")
        dispatcher.sendout(msg)
        self.assertTrue(True)

if __name__ == '__main__':
    unittest.main()
    